#ifndef ICFP_H

#define ICFP_H

#define DEBUG 0

/* Defines */

#define MAX_MAP_HEIGHT 1000
#define MAX_MAP_WIDTH  1000
#define MAX_PLAYERS    100000
#define MAX_PACKAGES   10000

#define MAX_HOME_BASES 1000
#define MAX_HOME_BASE_STANDOFF 100
#define MAX_HEUR_AT_BASE 100000

#define MAX_COMMAND_LENGTH 100000
#define MAX_CARRY_CAPACITY 1000000000
#define MAX_PACKAGE_WEIGHT 1000000000

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <ctype.h>

/* Variables */
char command[MAX_COMMAND_LENGTH];
char *server_hostname;
int server_port;  
int ssocket;
struct sockaddr_in socketaddr;
char buffer[40960];
int score;
int picked_up_packages;
int dropped_packages;

struct s_package{
  int id;
  int x;
  int y;
  int weight;
} packages[MAX_PACKAGES], carrying[MAX_PACKAGES];

struct {
  int id;
  int x;
  int y;
} players[MAX_PLAYERS];

struct {	
  char **loc;
  int width;
  int height;
} board;

struct {
	int id;
	int max_weight;
	int cash;
} robot;

struct {
	int x;
	int y;
	int standoff;
} bases[MAX_HOME_BASES];

/* Prototypes */
int ConnectToServer();
int WriteLine(char *write_buffer);
int ReadLine();
int ProcessCmdArguments(int argc, char *argv[]);
void AllocError();
void PrintBoard();
void GetBoard();
void GetConfig();
void EndGame();
void EndGame();
void RobotDeath();
void KillRobot(int i);
void MoveNorth(int robot_id);
void MoveSouth(int robot_id);
void MoveEast(int robot_id);
void PickupPackage(int robot_id, int package_id);
void DropPackage(int robot_id, int package_id);
char *ProcesReply(char *pointer);
int GetPlayerPosition();
void GetPackageList();
char *MakeCommand();
void PlayGame();
void InitialiseGame();
int debug(const char *fmt, ...);
#endif
