#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <ctype.h>

#include "icfp.h"


/* Process hostname and port */
int ProcessCmdArguments(int argc, char *argv[]) {
	if (argc != 3) {
		debug("Usage:\n./icfp hostname port\n\n");
		exit(1);
	}
	server_hostname = (char *)malloc(strlen(argv[1]) + 1);
	strcpy(server_hostname,argv[1]);
	server_port = atoi(argv[2]);
	return 1;
}

/* reads from ssocket until EOL, returns read chararray */
int ReadLine() {
	
	int number_of_bytes = 0;
	
	do {
		read(ssocket, &buffer[number_of_bytes],1);
		number_of_bytes++;
	} while(buffer[number_of_bytes - 1] != '\n');
	buffer[number_of_bytes] = '\0';
	debug("Reading: %s\n",buffer);
	if (strncmp(buffer,"Robot",5) == 0) 
		/* Probly wrong command or something */
		RobotDeath();
	return strlen(buffer);
}

/* writes buffer to ssocket, returns number written */
int WriteLine(char *write_buffer) {
	debug("Writing: %s\n",write_buffer);
	return write(ssocket, write_buffer, strlen(write_buffer));
}

/* connects to server, sets up ssocket */
int ConnectToServer() {
	char ipaddress[15];
	fd_set fd;
	struct timeval timeout;
	struct hostent *host_entry;

	FD_ZERO(&fd);
	FD_SET(ssocket,&fd);
	memset((char *)&timeout,0,sizeof(timeout));
	timeout.tv_sec = 10;

	if(server_port <= 0 || server_port > 65536) {
		debug("Port number not valid!\n");
		exit(1);
	}


	host_entry = gethostbyname(server_hostname);
	inet_ntop(AF_INET, host_entry->h_addr_list[0],ipaddress,15);
	if((ssocket = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		debug("Socket could not be set\n");
		exit(1);
	}	
	debug("Socket initalised...\n");

	memset(&socketaddr,0,sizeof(struct sockaddr));
	socketaddr.sin_port = htons(server_port);
	memcpy(&socketaddr.sin_addr,
	       host_entry->h_addr_list[0],
	       host_entry->h_length);

	socketaddr.sin_family = AF_INET;

	debug("Connecting...\n");

	if(connect(ssocket,(struct sockaddr *)&socketaddr,
		   sizeof(socketaddr)) < 0) {
		debug("Connection with %s failed...\n",server_hostname);
		close(ssocket);
		exit(1);
	}
	return 1;
}

